"use client";
import React, { ChangeEvent, useEffect, useRef, useState } from "react";
import { useForm, Controller } from "react-hook-form";
import { Input } from "@/components/ui/input";
import { Button } from "@/components/ui/button";
import { Label } from "@/components/ui/label";
import { Card } from "@/components/ui/card";
import { zodResolver } from "@hookform/resolvers/zod";
import * as z from "zod";
import Swal from "sweetalert2";
import withReactContent from "sweetalert2-react-content";
import { useParams, useRouter } from "next/navigation";
import {
  Select,
  SelectContent,
  SelectItem,
  SelectTrigger,
  SelectValue,
} from "@/components/ui/select";
import { Checkbox } from "@/components/ui/checkbox";
import { RadioGroup, RadioGroupItem } from "@/components/ui/radio-group";
import JoditEditor from "jodit-react";
import { register } from "module";
import { Switch } from "@/components/ui/switch";
import Cookies from "js-cookie";
import {
  createMedia,
  getTagsBySubCategoryId,
  listEnableCategory,
  rejectFiles,
  submitApproval,
} from "@/service/content/content";
import { detailMedia } from "@/service/curated-content/curated-content";
import { Badge } from "@/components/ui/badge";
import { MailIcon } from "lucide-react";
import { Swiper, SwiperSlide } from "swiper/react";
import "swiper/css";
import "swiper/css/free-mode";
import "swiper/css/navigation";
import "swiper/css/pagination";
import "swiper/css/thumbs";
import "swiper/css";
import "swiper/css/navigation";
import { FreeMode, Navigation, Pagination, Thumbs } from "swiper/modules";
import {
  DialogHeader,
  DialogFooter,
  Dialog,
  DialogContent,
  DialogTitle,
} from "@/components/ui/dialog";
import { Textarea } from "@/components/ui/textarea";
import { loading } from "@/config/swal";
import { getCookiesDecrypt } from "@/lib/utils";
import { Icon } from "@iconify/react/dist/iconify.js";
import { error } from "@/lib/swal";
import dynamic from "next/dynamic";

const imageSchema = z.object({
  title: z.string().min(1, { message: "Judul diperlukan" }),
  description: z
    .string()
    .min(2, { message: "Narasi Penugasan harus lebih dari 2 karakter." }),
  creatorName: z.string().min(1, { message: "Creator diperlukan" }),
  // tags: z.string().min(1, { message: "Judul diperlukan" }),
});

type Category = {
  id: string;
  name: string;
};

type FileType = {
  id: number;
  url: string;
  thumbnailFileUrl: string;
  fileName: string;
};

type Detail = {
  id: string;
  title: string;
  description: string;
  slug: string;
  category: {
    id: number;
    name: string;
  };
  categoryName: string;
  creatorName: string;
  thumbnailLink: string;
  url: string;
  tags: string;
  statusName: string;
  isPublish: boolean;
  needApprovalFromLevel: number;
  files: FileType[];
  uploadedById: number;
};

const ViewEditor = dynamic(
  () => {
    return import("@/components/editor/view-editor");
  },
  { ssr: false }
);

export default function FormVideoDetail() {
  const MySwal = withReactContent(Swal);
  const router = useRouter();
  const userId = getCookiesDecrypt("uie");
  const userLevelId = getCookiesDecrypt("ulie");
  const roleId = getCookiesDecrypt("urie");

  const [modalOpen, setModalOpen] = useState(false);
  const { id } = useParams() as { id: string };
  console.log(id);
  const editor = useRef(null);
  type ImageSchema = z.infer<typeof imageSchema>;

  const [selectedFiles, setSelectedFiles] = useState<File[]>([]);
  const taskId = Cookies.get("taskId");
  const scheduleId = Cookies.get("scheduleId");
  const scheduleType = Cookies.get("scheduleType");
  const [status, setStatus] = useState("");
  const [categories, setCategories] = useState<Category[]>([]);
  const [selectedCategory, setSelectedCategory] = useState<any>();
  const [tags, setTags] = useState<any[]>([]);
  const [detail, setDetail] = useState<any>();
  const [refresh, setRefresh] = useState(false);
  const [selectedPublishers, setSelectedPublishers] = useState<number[]>([]);
  const [description, setDescription] = useState("");
  const [main, setMain] = useState<any>([]);
  const [detailVideo, setDetailVideo] = useState<any>([]);
  const [thumbsSwiper, setThumbsSwiper] = useState<any>(null);

  const [filePlacements, setFilePlacements] = useState<string[][]>([]);
  const [selectedTarget, setSelectedTarget] = useState("");
  const [files, setFiles] = useState<FileType[]>([]);
  const [rejectedFiles, setRejectedFiles] = useState<number[]>([]);
  const [isUserMabesApprover, setIsUserMabesApprover] = useState(false);

  let fileTypeId = "2";

  const {
    control,
    handleSubmit,
    setValue,
    formState: { errors },
  } = useForm<ImageSchema>({
    resolver: zodResolver(imageSchema),
  });

  // const handleKeyDown = (e: any) => {
  //   const newTag = e.target.value.trim(); // Ambil nilai input
  //   if (e.key === "Enter" && newTag) {
  //     e.preventDefault(); // Hentikan submit form
  //     if (!tags.includes(newTag)) {
  //       setTags((prevTags) => [...prevTags, newTag]); // Tambah tag baru
  //       setValue("tags", ""); // Kosongkan input
  //     }
  //   }
  // };

  useEffect(() => {
    if (
      userLevelId != undefined &&
      roleId != undefined &&
      userLevelId == "216" &&
      roleId == "3"
    ) {
      setIsUserMabesApprover(true);
    }
  }, [userLevelId, roleId]);

  const handleCheckboxChange = (id: number) => {
    setSelectedPublishers((prev) =>
      prev.includes(id) ? prev.filter((item) => item !== id) : [...prev, id]
    );
  };

  useEffect(() => {
    async function initState() {
      getCategories();
    }

    initState();
  }, []);

  const getCategories = async () => {
    try {
      const category = await listEnableCategory(fileTypeId);
      const resCategory: Category[] = category?.data?.data?.content;

      setCategories(resCategory);
      console.log("data category", resCategory);

      if (scheduleId && scheduleType === "3") {
        const findCategory = resCategory.find((o) =>
          o.name.toLowerCase().includes("pers rilis")
        );

        if (findCategory) {
          // setValue("categoryId", findCategory.id);
          setSelectedCategory(findCategory.id); // Set the selected category
          const response = await getTagsBySubCategoryId(findCategory.id);
          setTags(response?.data.data);
        }
      }
    } catch (error) {
      console.error("Failed to fetch categories:", error);
    }
  };

  useEffect(() => {
    async function initState() {
      if (id) {
        const response = await detailMedia(id);
        const details = response?.data?.data;
        console.log("detail", details);
        setFiles(details?.files);
        setDetail(details);
        setMain({
          type: details?.fileType.name,
          url: details?.files[0]?.url,
          names: details?.files[0]?.fileName,
          format: details?.files[0]?.format,
        });

        if (details.publishedForObject) {
          const publisherIds = details.publishedForObject.map(
            (obj: any) => obj.id
          );
          setSelectedPublishers(publisherIds);
        }

        const matchingCategory = categories.find(
          (category) => category.id === details.categoryId
        );

        if (matchingCategory) {
          setSelectedTarget(matchingCategory.name);
        }

        setSelectedTarget(details.categoryId); // Untuk dropdown

        const filesData = details.files || [];
        const fileUrls = filesData.map((files: { url: string }) =>
          files.url ? files.url : "default-image.jpg"
        );
        setDetailVideo(fileUrls);
      }
    }
    initState();
  }, [refresh, setValue]);

  const actionApproval = (e: string) => {
    const temp = [];
    for (const element of detail.files) {
      temp.push([]);
    }
    setFilePlacements(temp);
    setStatus(e);
    setFiles(detail.files);

    setDescription("");
    setModalOpen(true);
  };

  const submit = async () => {
    if (
      (description?.length > 1 && Number(status) == 3) ||
      Number(status) == 2 ||
      Number(status) == 4
    ) {
      MySwal.fire({
        title: "Simpan Approval",
        text: "",
        icon: "warning",
        showCancelButton: true,
        cancelButtonColor: "#d33",
        confirmButtonColor: "#3085d6",
        confirmButtonText: "Simpan",
      }).then((result) => {
        if (result.isConfirmed) {
          save();
        }
      });
    }
  };

  async function save() {
    const data = {
      mediaUploadId: id,
      statusId: status,
      message: description,
      files: isUserMabesApprover ? getPlacement() : [],
    };

    loading();
    const response = await submitApproval(data);

    if (response?.error) {
      error(response.message);
      return false;
    }

    const dataReject = {
      listFiles: rejectedFiles,
    };

    const resReject = await rejectFiles(dataReject);

    if (resReject?.error) {
      error(resReject.message);
      return false;
    }

    close();
    submitApprovalSuccesss();

    return false;
  }

  const getPlacement = () => {
    console.log("getPlaa", filePlacements);
    const temp = [];
    for (let i = 0; i < filePlacements?.length; i++) {
      if (filePlacements[i].length !== 0) {
        const now = filePlacements[i].filter((a) => a !== "all");
        const data = { mediaFileId: files[i].id, placement: now.join(",") };
        temp.push(data);
      }
    }
    return temp;
  };

  const setupPlacement = (
    index: number,
    placement: string,
    checked: boolean
  ) => {
    let temp = [...filePlacements];
    if (checked) {
      if (placement === "all") {
        temp[index] = ["all", "mabes", "polda", "international"];
      } else {
        const now = temp[index];
        now.push(placement);
        if (now.length === 3 && !now.includes("all")) {
          now.push("all");
        }
        temp[index] = now;
      }
    } else {
      if (placement === "all") {
        temp[index] = [];
      } else {
        const now = temp[index].filter((a) => a !== placement);
        console.log("now", now);
        temp[index] = now;
        if (now.length === 3 && now.includes("all")) {
          const newData = now.filter((b) => b !== "all");
          temp[index] = newData;
        }
      }
    }
    setFilePlacements(temp);
  };

  function handleDeleteFileApproval(id: number) {
    const selectedFiles = files.filter((file) => file.id != id);
    setFiles(selectedFiles);
    const rejects = rejectedFiles;
    rejects.push(id);
    setRejectedFiles(rejects);
  }
  const handleMain = (
    type: string,
    url: string,
    names: string,
    format: string
  ) => {
    console.log("Test 3 :", type, url, names, format);
    setMain({
      type,
      url,
      names,
      format,
    });
    return false;
  };

  const submitApprovalSuccesss = () => {
    MySwal.fire({
      title: "Sukses",
      text: "Data berhasil disimpan.",
      icon: "success",
      confirmButtonColor: "#3085d6",
      confirmButtonText: "OK",
    }).then((result) => {
      if (result.isConfirmed) {
        router.push("/contributor/content/video");
      }
    });
  };

  return (
    <form>
      {detail !== undefined ? (
        <div className="flex lg:flex-row gap-10">
          <Card className="w-full lg:w-8/12">
            <div className="px-6 py-6">
              <p className="text-lg font-semibold mb-3">
                Form Detail Konten Video
              </p>
              <div className="gap-5 mb-5">
                {/* Input Title */}
                <div className="space-y-2 py-3">
                  <Label>Judul</Label>
                  <Controller
                    control={control}
                    name="title"
                    render={({ field }) => (
                      <Input
                        size="md"
                        type="text"
                        value={detail?.title}
                        onChange={field.onChange}
                        placeholder="Enter Title"
                      />
                    )}
                  />
                  {errors.title?.message && (
                    <p className="text-red-400 text-sm">
                      {errors.title.message}
                    </p>
                  )}
                </div>
                <div className="flex items-center">
                  <div className="py-3 w-full">
                    <Label>Kategori</Label>
                    <Select
                      value={detail?.category.name} // Nilai default berdasarkan detail
                      onValueChange={(id) => {
                        console.log("Selected Category:", id);
                        setSelectedTarget(id);
                      }}
                    >
                      <SelectTrigger size="md">
                        <SelectValue placeholder="Pilih" />
                      </SelectTrigger>
                      <SelectContent>
                        {categories.map((category) => (
                          <SelectItem key={category.id} value={category.name}>
                            {category.name}
                          </SelectItem>
                        ))}
                      </SelectContent>
                    </Select>
                  </div>
                </div>

                <div className="py-3">
                  <Label>Deskripsi</Label>
                  <Controller
                    control={control}
                    name="description"
                    render={({ field: { onChange, value } }) => (
                      <ViewEditor initialData={detail?.htmlDescription} />
                    )}
                  />
                  {errors.description?.message && (
                    <p className="text-red-400 text-sm">
                      {errors.description.message}
                    </p>
                  )}
                </div>

                <Label className="text-xl text-black">File Mediaa</Label>
                <div className="w-full  ">
                  <Swiper
                    thumbs={{ swiper: thumbsSwiper }}
                    modules={[FreeMode, Navigation, Thumbs]}
                    navigation={false}
                    className="w-full"
                  >
                    {detailVideo?.map((data: any) => (
                      <SwiperSlide key={data.id}>
                        <video
                          className="object-fill h-full w-full"
                          src={data}
                          controls
                          title={`Video ${data.id}`} // Mengganti alt dengan title
                        />
                      </SwiperSlide>
                    ))}
                  </Swiper>
                  <div className=" mt-2 ">
                    <Swiper
                      onSwiper={setThumbsSwiper}
                      slidesPerView={6}
                      spaceBetween={8}
                      pagination={{
                        clickable: true,
                      }}
                      modules={[Pagination, Thumbs]}
                      // className="mySwiper2"
                    >
                      {detailVideo?.map((data: any) => (
                        <SwiperSlide key={data.id}>
                          <video
                            className="object-cover h-[60px] w-[80px]"
                            src={data}
                            muted
                            title={`Video ${data.id}`} // Mengganti alt dengan title
                          />
                        </SwiperSlide>
                      ))}
                    </Swiper>
                  </div>
                </div>
              </div>
            </div>
          </Card>
          <div className="w-4/12">
            <Card className=" h-[800px]">
              <div className="px-3 py-3">
                <div className="space-y-2">
                  <Label>Kreator</Label>
                  <Controller
                    control={control}
                    name="creatorName"
                    render={({ field }) => (
                      <Input
                        size="md"
                        type="text"
                        value={detail?.creatorName}
                        onChange={field.onChange}
                        placeholder="Enter Title"
                      />
                    )}
                  />
                  {errors.creatorName?.message && (
                    <p className="text-red-400 text-sm">
                      {errors.creatorName.message}
                    </p>
                  )}
                </div>
              </div>
              <div className="mt-3 px-3">
                <Label>Pratinjau Gambar Utama</Label>
                <Card className="mt-2">
                  <img
                    src={detail.thumbnailLink}
                    alt="Thumbnail Gambar Utama"
                    className="w-full h-auto rounded"
                  />
                </Card>
              </div>
              <div className="px-3 py-3">
                <div className="space-y-2">
                  <Label>Tag</Label>
                  <div className="flex flex-wrap gap-2">
                    {detail?.tags
                      ?.split(",")
                      .map((tag: string, index: number) => (
                        <Badge
                          key={index}
                          className="border rounded-md  px-2 py-2"
                        >
                          {tag.trim()}
                        </Badge>
                      ))}
                  </div>
                </div>
              </div>
              <div className="px-3 py-3">
                <div className="flex flex-col gap-6">
                  <Label>Target Publish</Label>
                  <div className="flex gap-2 items-center">
                    <Checkbox
                      id="5"
                      checked={selectedPublishers.includes(5)}
                      onChange={() => handleCheckboxChange(5)}
                    />
                    <Label htmlFor="5">UMUM</Label>
                  </div>
                  <div className="flex gap-2 items-center">
                    <Checkbox
                      id="6"
                      checked={selectedPublishers.includes(6)}
                      onChange={() => handleCheckboxChange(6)}
                    />
                    <Label htmlFor="6">JOURNALIS</Label>
                  </div>
                  <div className="flex gap-2 items-center">
                    <Checkbox
                      id="7"
                      checked={selectedPublishers.includes(7)}
                      onChange={() => handleCheckboxChange(7)}
                    />
                    <Label htmlFor="7">POLRI</Label>
                  </div>
                  <div className="flex gap-2 items-center">
                    <Checkbox
                      id="8"
                      checked={selectedPublishers.includes(8)}
                      onChange={() => handleCheckboxChange(8)}
                    />
                    <Label htmlFor="8">KSP</Label>
                  </div>
                </div>
              </div>
              <div className="px-3 py-3 flex flex-row items-center text-blue-500 gap-2 text-sm">
                <MailIcon />
                <p className="">Kotak Saran (0)</p>
              </div>
              <div className="px-3 py-3 border mx-3">
                <p>Keterangan:</p>
                <p className="text-sm text-slate-400">{detail?.statusName}</p>
              </div>
              {/* {detail?.isPublish == false ? (
                <div className="p-3">
                  <Button className="bg-blue-600">Publish</Button>
                </div>
              ) : (
                ""
              )} */}
              {Number(detail?.needApprovalFromLevel) == Number(userLevelId) ? (
                Number(detail?.uploadedById) == Number(userId) ? (
                  ""
                ) : (
                  <div className="flex flex-col gap-2 p-3">
                    <Button
                      onClick={() => actionApproval("2")}
                      color="primary"
                      type="button"
                    >
                      <Icon icon="fa:check" className="mr-3" /> Setujui
                    </Button>
                    <Button
                      onClick={() => actionApproval("3")}
                      className="bg-orange-400 hover:bg-orange-300"
                      type="button"
                    >
                      <Icon icon="fa:comment-o" className="mr-3" /> Revisi
                    </Button>
                    <Button
                      onClick={() => actionApproval("4")}
                      color="destructive"
                      type="button"
                    >
                      <Icon icon="fa:times" className="mr-3" />
                      Tolak
                    </Button>
                  </div>
                )
              ) : (
                ""
              )}

              <Dialog open={modalOpen} onOpenChange={setModalOpen}>
                <DialogContent size="md">
                  <DialogHeader>
                    <DialogTitle>Berikan Komentar</DialogTitle>
                  </DialogHeader>
                  {status == "2"
                    ? files?.map((file, index) => (
                        <div
                          key={file.id}
                          className="flex flex-row gap-2 items-center"
                        >
                          <img src={file.url} className="w-[200px]" />
                          <div className="flex flex-col gap-2 w-full">
                            <div className="flex justify-between text-sm">
                              {file.fileName}
                              <a
                                onClick={() =>
                                  handleDeleteFileApproval(file.id)
                                }
                              >
                                <Icon icon="humbleicons:times" color="red" />
                              </a>
                            </div>
                            {isUserMabesApprover &&
                              <div className="flex flex-row gap-2">
                                <div className="flex items-center space-x-2">
                                  <Checkbox
                                    id="terms"
                                    value="all"
                                    checked={filePlacements[index]?.includes(
                                      "all"
                                    )}
                                    onCheckedChange={(e) =>
                                      setupPlacement(index, "all", Boolean(e))
                                    }
                                  />
                                  <label
                                    htmlFor="terms"
                                    className="text-xs font-medium leading-none peer-disabled:cursor-not-allowed peer-disabled:opacity-70"
                                  >
                                    Semua
                                  </label>
                                </div>
                                <div className="flex items-center space-x-2">
                                  <Checkbox
                                    id="terms"
                                    checked={filePlacements[index]?.includes(
                                      "mabes"
                                    )}
                                    onCheckedChange={(e) =>
                                      setupPlacement(index, "mabes", Boolean(e))
                                    }
                                  />
                                  <label
                                    htmlFor="terms"
                                    className="text-xs font-medium leading-none peer-disabled:cursor-not-allowed peer-disabled:opacity-70"
                                  >
                                    Nasional
                                  </label>
                                </div>
                                <div className="flex items-center space-x-2">
                                  <Checkbox
                                    id="terms"
                                    checked={filePlacements[index]?.includes(
                                      "polda"
                                    )}
                                    onCheckedChange={(e) =>
                                      setupPlacement(index, "polda", Boolean(e))
                                    }
                                  />
                                  <label
                                    htmlFor="terms"
                                    className="text-xs font-medium leading-none peer-disabled:cursor-not-allowed peer-disabled:opacity-70"
                                  >
                                    Wilayah
                                  </label>
                                </div>

                                <div className="flex items-center space-x-2">
                                  <Checkbox
                                    id="terms"
                                    checked={filePlacements[index]?.includes(
                                      "international"
                                    )}
                                    onCheckedChange={(e) =>
                                      setupPlacement(
                                        index,
                                        "international",
                                        Boolean(e)
                                      )
                                    }
                                  />
                                  <label
                                    htmlFor="terms"
                                    className="text-xs font-medium leading-none peer-disabled:cursor-not-allowed peer-disabled:opacity-70"
                                  >
                                    Internasional
                                  </label>
                                </div>
                              </div>
                            }
                          </div>
                        </div>
                      ))
                    : ""}
                  <div className="flex flex-col gap-4">
                    <Textarea
                      placeholder="Type your message here."
                      value={description}
                      onChange={(e) => setDescription(e.target.value)}
                    />
                  </div>
                  {status == "3" || status == "4" ? (
                    <div className="flex flex-row gap-2">
                      <Badge
                        color={
                          description === "Kualitas media kurang baik"
                            ? "primary"
                            : "default"
                        }
                        className="cursor-pointer"
                        onClick={() =>
                          setDescription("Kualitas media kurang baik")
                        }
                      >
                        Kualitas media kurang baik
                      </Badge>

                      <Badge
                        color={
                          description === "Deskripsi kurang lengkap"
                            ? "primary"
                            : "default"
                        }
                        className="cursor-pointer"
                        onClick={() =>
                          setDescription("Deskripsi kurang lengkap")
                        }
                      >
                        Deskripsi kurang lengkap
                      </Badge>
                      <Badge
                        color={
                          description === "Judul kurang tepat"
                            ? "primary"
                            : "default"
                        }
                        className="cursor-pointer"
                        onClick={() => setDescription("Judul kurang tepat")}
                      >
                        Judul kurang tepat
                      </Badge>
                    </div>
                  ) : (
                    <div className="flex flex-row gap-2">
                      <Badge
                        color={
                          description === "Konten sangat bagus"
                            ? "primary"
                            : "default"
                        }
                        className="cursor-pointer"
                        onClick={() => setDescription("Konten sangat bagus")}
                      >
                        Konten sangat bagus
                      </Badge>
                      <Badge
                        color={
                          description === "Konten menarik"
                            ? "primary"
                            : "default"
                        }
                        className="cursor-pointer"
                        onClick={() => setDescription("Konten menarik")}
                      >
                        Konten menarik
                      </Badge>
                    </div>
                  )}
                  <DialogFooter>
                    <Button
                      type="button"
                      color="primary"
                      onClick={() => submit()}
                    >
                      Submit
                    </Button>
                    <Button
                      type="button"
                      color="destructive"
                      onClick={() => setModalOpen(false)}
                    >
                      Cancel
                    </Button>
                  </DialogFooter>
                </DialogContent>
              </Dialog>
            </Card>
          </div>
        </div>
      ) : (
        ""
      )}
    </form>
  );
}
